@Library('github.com/releaseworks/jenkinslib') _

pipeline {
    agent any

    environment {
        PORT = 80
        TAG = "latest"
        cowsay_ec2_ip = '65.2.4.18'
        remoteUser = 'ubuntu'
        remoteHost = 'ec2-13.233.116.48.ap-south-1.compute.amazonaws.com'
        remoteDir = '/home/ubuntu/'
    }

    stages {
        stage('Login to AWS ECR') {
            steps {
                script {
                    withCredentials([[$class: 'AmazonWebServicesCredentialsBinding', credentialsId: 'a851fc26-329b-48f7-a93e-83768d9a6ebd']]) {
                        sh "aws ecr-public get-login-password --region us-east-1 | docker login --username AWS --password-stdin public.ecr.aws/c7o8u9c1"
                    }
                }
            }
        }

        stage('Edit vars according to Branch staging') {
            when {
                branch 'staging'
            }
            steps {
                script {
                    PORT = 3000
                    TAG = "staging"
                }
            }
        }


        stage('Build') {
            steps {
                sh 'docker build -t bootcamp-20-itamar .'
            }
        }

        stage('Edit vars according to Branch Feature') {
            when {
                branch 'feature/*'
            }
            steps {
                script {
                    TAG = "feature"
                }
            }
        }

        stage('publish') {
            steps {
                sh "docker tag bootcamp-20-itamar:\${TAG} public.ecr.aws/c7o8u9c1/bootcamp-20-itamar:${TAG}"
                sh "docker push public.ecr.aws/c7o8u9c1/bootcamp-20-itamar:${TAG}"
            }
        }


        stage('Feature Branch - Test Locally & Cleanup') {
            when {
                branch 'feature/*'
            }
            steps {
                script {
                    sshagent(credentials: ['93f74152-c257-40b4-9aa7-b394ab4d133e']) {
                    sh "docker compose up"
                    }

                    def runningContainers = sh(script: 'docker ps -q', returnStdout: true).trim()
                    sh "echo $runningContainers"
                    sh "sleep 5"
                    if (runningContainers) {
                        echo "There are running containers:"
                    } else {
                        echo "No running containers found."
                    }
                }
            }
            post {
                always {
                    script {
                         sh "docker compose down"
                         return
                    }
                }
            }
        }

        stage("Deploy") {
            steps {
                script {
                    sshagent(credentials: ['93f74152-c257-40b4-9aa7-b394ab4d133e']) {
                        sh "scp -o StrictHostKeyChecking=no compose.yaml ubuntu@${cowsay_ec2_ip}:${remoteDir}"
                        sh "ssh ubuntu@${cowsay_ec2_ip} PORT=$PORT docker compose up -d"             
                        }
                    }
                }
        }


        stage('Test') {
            steps {
                script {
                    echo 'Running tests...'
                    echo 'running tests...'
                    
                def responseCode = sh(script: "curl -s -o /dev/null -w \"%{http_code}\" http://${cowsay_ec2_ip}:${PORT}/", returnStdout: true).trim()
                sh "echo $responseCode"
                    if ( responseCode == 200 ) {
                        echo "Passed tests successfully"
                    } else {
                        echo "Test Failed"
                    }
                }
            }
        }

    }
}

